#!/usr/bin/python

import socket
import argparse
import os
import sys
import fcntl

import xml.etree.ElementTree as xml

parser = argparse.ArgumentParser()
parser.add_argument("address", help="address to listen on")
parser.add_argument("port", help="port to listen on", type=int)
parser.add_argument("-i", "--image", action="append", help="ploop image path")
args = parser.parse_args()

server = socket.socket()
server.bind((args.address, args.port))
server.listen(1)

rpc, a = server.accept()
mem, a = server.accept()


fds = []
fdsarg = []

if args.image:
    for img in args.image:
        fd, a = server.accept()
        # keep fd somewhere or it will be closed
        fds.append(fd)
        fdsarg.append('{}:{}'.format(img, fd.fileno()))

server.close()

hargs = [ "phaul",
         "--fdrpc", str(rpc.fileno()),
         "--fdmem", str(mem.fileno()),
         "--log-file", "/var/log/phaul-service.log" ]

if fdsarg:
    hargs.extend(["--fdfs", ','.join(fdsarg)])

print ' '.join(hargs)
sys.stdout.flush()
os.execv("/usr/libexec/phaul/p.haul-service", hargs)
